#include <jni.h>      /* Java Native Interface headers */
#include "EuropeanOptPriceGreeks.h"   /* Auto-generated header created by javah -jni */
#include <nag.h>      /* NAG C Library headers */
#include <nags.h>

/* Our C definition of the function s30abc declared in EuropeanOptPrice.java */
JNIEXPORT jint JNICALL Java_EuropeanOptPriceGreeks_s30abc
  (JNIEnv *env, jobject obj, jchar calput, jint m, jint n, jdoubleArray x, 
   jdouble s, jdoubleArray t, jdouble sigma, jdouble r, jdouble q, 
   jdoubleArray p, jdoubleArray delta, jdoubleArray gamma, 
   jdoubleArray vega, jdoubleArray theta, jdoubleArray rho, jdoubleArray crho, 
   jdoubleArray vanna, jdoubleArray charm, jdoubleArray speed, 
   jdoubleArray colour, jdoubleArray zomma, jdoubleArray vomma)
{ 
  static NagError fail;
  Nag_CallPut iput;
  Nag_OrderType order;

  /* First extract the arrays from Java */
  jdouble *xpt, *tpt, *ppt, *deltapt, *gammapt, *vegapt, *thetapt, *rhopt,
          *crhopt, *vannapt, *charmpt, *speedpt, *colourpt, *zommapt, *vommapt;
  jboolean isCopy;

  xpt = (*env)->GetDoubleArrayElements(env, x, &isCopy);
  tpt = (*env)->GetDoubleArrayElements(env, t, &isCopy);
  ppt = (*env)->GetDoubleArrayElements(env, p, &isCopy);
  deltapt = (*env)->GetDoubleArrayElements(env, delta, &isCopy);
  gammapt = (*env)->GetDoubleArrayElements(env, gamma, &isCopy);
  vegapt = (*env)->GetDoubleArrayElements(env, vega, &isCopy);
  thetapt = (*env)->GetDoubleArrayElements(env, theta, &isCopy);
  rhopt = (*env)->GetDoubleArrayElements(env, rho, &isCopy);
  crhopt = (*env)->GetDoubleArrayElements(env, crho, &isCopy);
  vannapt = (*env)->GetDoubleArrayElements(env, vanna, &isCopy);
  charmpt = (*env)->GetDoubleArrayElements(env, charm, &isCopy);
  speedpt = (*env)->GetDoubleArrayElements(env, speed, &isCopy);
  colourpt = (*env)->GetDoubleArrayElements(env, colour, &isCopy);
  zommapt = (*env)->GetDoubleArrayElements(env, zomma, &isCopy);
  vommapt = (*env)->GetDoubleArrayElements(env, vomma, &isCopy);

  /* Java stores arrays in row order */
  order = Nag_RowMajor;

  /* Convert calput into Nag_CallPut */
  if (calput == 'P')
    {
      iput = Nag_Put;
    }
  else if (calput == 'C')
    {
      iput = Nag_Call;
    }

  /* Call s30abc */
  fail.print = Nag_FALSE;
  s30abc(order, iput, m, n, xpt, s, tpt, sigma, r, q, ppt, deltapt,  
         gammapt, vegapt, thetapt, rhopt, crhopt, vannapt, charmpt, speedpt,
         colourpt, zommapt, vommapt, &fail);

  /* Release the array elements back to Java */
  (*env)->ReleaseDoubleArrayElements(env, x, xpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, t, tpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, p, ppt, 0);
  (*env)->ReleaseDoubleArrayElements(env, delta, deltapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, gamma, gammapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, vega, vegapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, theta, thetapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, rho, rhopt, 0);
  (*env)->ReleaseDoubleArrayElements(env, crho, crhopt, 0);
  (*env)->ReleaseDoubleArrayElements(env, vanna, vannapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, charm, charmpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, speed, speedpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, colour, colourpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, zomma, zommapt, 0);
  (*env)->ReleaseDoubleArrayElements(env, vomma, vommapt, 0);

  return fail.code;
}
