#include <jni.h>      /* Java Native Interface headers */
#include "LinearEquations.h"   /* Auto-generated header created by javah -jni */

#include <nag.h>      /* NAG C Library headers */
#include <nagf04.h>

/* Our C definition of the function f04arc declared in LinearEquations.java */
JNIEXPORT jint JNICALL Java_LinearEquations_f04arc
  (JNIEnv *env, jobject obj, jint n, jdoubleArray a, jint tda,
   jdoubleArray b, jdoubleArray x)
{
  static NagError fail;

  /* First extract the arrays from Java */
  jdouble *apt, *bpt, *xpt;
  jsize len;
  int i;
  jboolean isCopy;

  apt = (*env)->GetDoubleArrayElements(env, a, &isCopy);
  bpt = (*env)->GetDoubleArrayElements(env, b, &isCopy);
  xpt = (*env)->GetDoubleArrayElements(env, x, &isCopy);

  /* Call f04arc */
  fail.print = Nag_FALSE;
  f04arc(n, apt, tda, bpt, xpt, &fail);

  /* Release the array elements back to Java */
  (*env)->ReleaseDoubleArrayElements(env, a, apt, 0);
  (*env)->ReleaseDoubleArrayElements(env, b, bpt, 0);
  (*env)->ReleaseDoubleArrayElements(env, x, xpt, 0);

  return fail.code;
}
